## dracut 108

=== Makefile ===
-include dracut-version.sh

DRACUT_MAIN_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_MAIN_VERSION),)
DRACUT_MAIN_VERSION = $(DRACUT_VERSION)
endif
DRACUT_FULL_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_FULL_VERSION),)
DRACUT_FULL_VERSION = $(DRACUT_VERSION)
endif

HAVE_SHELLCHECK ?= $(shell command -v shellcheck >/dev/null 2>&1 && echo yes)
HAVE_SHFMT ?= $(shell command -v shfmt >/dev/null  2>&1 && echo yes)

-include Makefile.inc

KVERSION ?= $(shell uname -r)

prefix ?= /usr
libdir ?= ${prefix}/lib
datadir ?= ${prefix}/share
pkglibdir ?= ${libdir}/dracut
sysconfdir ?= ${prefix}/etc
bindir ?= ${prefix}/bin
mandir ?= ${prefix}/share/man
CFLAGS ?= -O2 -g -Wall -std=gnu99 -D_FILE_OFFSET_BITS=64 -Wformat -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2
bashcompletiondir ?= ${datadir}/bash-completion/completions
pkgconfigdatadir ?= $(datadir)/pkgconfig

configs = \
	fips/10-fips.conf \
	generic/11-generic.conf \
	hostonly/10-hostonly.conf \
	ima/10-ima.conf \
	no-network/10-no-network.conf \
	no-xattr/10-no-xattr.conf \
	rescue/10-rescue.conf \
	uki-virt/10-uki-virt.conf \
	$(NULL)

test_configs = \
	test-makeroot/test-makeroot.conf \
	test-root/test-root.conf \
	test/test.conf \
	$(NULL)

man1pages = man/lsinitrd.1

man5pages = man/dracut.conf.5

man7pages = man/dracut.cmdline.7 \
            man/dracut.bootup.7 \
            man/dracut.modules.7

man8pages = man/dracut.8 \
            man/dracut-catimages.8 \
            modules.d/77dracut-systemd/dracut-cmdline.service.8 \
            modules.d/77dracut-systemd/dracut-mount.service.8 \
            modules.d/77dracut-systemd/dracut-shutdown.service.8 \
            modules.d/77dracut-systemd/dracut-pre-mount.service.8 \
            modules.d/77dracut-systemd/dracut-pre-pivot.service.8 \
            modules.d/77dracut-systemd/dracut-pre-trigger.service.8 \
            modules.d/77dracut-systemd/dracut-pre-udev.service.8 \
            modules.d/77initqueue/dracut-initqueue.service.8

manpages = $(man1pages) $(man5pages) $(man7pages) $(man8pages)

.PHONY: install clean archive test all check AUTHORS CONTRIBUTORS doc

all: dracut.pc dracut-install src/skipcpio/skipcpio dracut-util

%.o : %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(KMOD_CFLAGS) $(SYSTEMD_CFLAGS) $(if $(SYSTEMD_LIBS),-DHAVE_SYSTEMD) $< -o $@

DRACUT_INSTALL_OBJECTS = \
        src/install/dracut-install.o \
        src/install/hashmap.o\
        src/install/log.o \
        src/install/strv.o \
        src/install/util.o

# deps generated with gcc -MM
src/install/dracut-install.o: src/install/dracut-install.c src/install/log.h src/install/macro.h \
	src/install/hashmap.h src/install/util.h
src/install/hashmap.o: src/install/hashmap.c src/install/util.h src/install/macro.h src/install/log.h \
	src/install/hashmap.h
src/install/log.o: src/install/log.c src/install/log.h src/install/macro.h src/install/util.h
src/install/util.o: src/install/util.c src/install/util.h src/install/macro.h src/install/log.h
src/install/strv.o: src/install/strv.c src/install/strv.h src/install/util.h src/install/macro.h src/install/log.h

src/install/dracut-install: $(DRACUT_INSTALL_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(DRACUT_INSTALL_OBJECTS) $(LDLIBS) $(FTS_LIBS) $(KMOD_LIBS) $(SYSTEMD_LIBS)

dracut-install: src/install/dracut-install
	ln -fs $< $@

SKIPCPIO_OBJECTS = src/skipcpio/skipcpio.o
skipcpio/skipcpio.o: src/skipcpio/skipcpio.c
skipcpio/skipcpio: $(SKIPCPIO_OBJECTS)

UTIL_OBJECTS = src/util/util.o
util/util.o: src/util/util.c
util/util: $(UTIL_OBJECTS)

dracut-util: src/util/util
	cp -a $< $@

.PHONY: indent-c
indent-c:
	astyle -n --quiet --options=.astylerc $(wildcard *.[ch] */*.[ch] src/*/*.[ch])

.PHONY: indent
indent: indent-c
ifeq ($(HAVE_SHFMT),yes)
	shfmt -w -s .
endif

src/dracut-cpio/target/release/dracut-cpio: src/dracut-cpio/src/main.rs
	cargo --offline build --release --manifest-path src/dracut-cpio/Cargo.toml

dracut-cpio: src/dracut-cpio/target/release/dracut-cpio
	ln -fs $< $@

ifeq ($(enable_dracut_cpio),yes)
all: dracut-cpio
endif

doc: $(manpages)

ifneq ($(enable_documentation),no)
all: doc
endif

ifeq ($(disable_asciidoctor),yes)
$(warning *** Building with asciidoc deprecated)
%: %.xml
	@rm -f -- "$@"
	xsltproc -o "$@" -nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl $<

%.xml: %.adoc
	@rm -f -- "$@"
	asciidoc -f man/asciidoc.conf -a "version=$(DRACUT_FULL_VERSION)" -d manpage -b docbook -o "$@" $<
else
define ASCIIDOC_MANPAGE
	asciidoctor -a "version=$(DRACUT_FULL_VERSION)" -b manpage $<
endef

%.1: %.1.adoc
	$(ASCIIDOC_MANPAGE)
%.5: %.5.adoc
	$(ASCIIDOC_MANPAGE)
%.7: %.7.adoc
	$(ASCIIDOC_MANPAGE)
%.8: %.8.adoc
	$(ASCIIDOC_MANPAGE)
endif

# If ANOTRA_BIN not set, default to look for "npx" to run "npx antora".  If we
# end up with undefined ANTORA_BIN (i.e. not set and npx not found), we'll give
# a sane error when building docs below.
ifeq ($(ANTORA_BIN),)
NPX := $(shell command -v npx 2> /dev/null)
ifneq ($(NPX),)
ANTORA_BIN := "$(NPX) antora"
endif
endif
.PHONY: doc_site
doc_site: $(manpages) doc_site/modules/ROOT/nav.adoc doc_site/modules/ROOT/pages/index.adoc
ifndef ANTORA_BIN
	$(error Antora not found, install nodejs or set ANTORA_BIN to make doc site)
endif
	mkdir -p doc_site/modules/ROOT/pages/man
	cd doc_site/modules/ROOT/pages/man/; for i in $(manpages) man/dracut.usage; do ln -sf ../../../../../$${i}.adoc $(basename $i); done
	$(shell echo $(ANTORA_BIN)) --attribute "mainversion=$(DRACUT_MAIN_VERSION)" \
	  --attribute "version=${DRACUT_FULL_VERSION}" \
	  antora-playbook.yml

dracut.8: man/dracut.8.adoc \
	man/dracut.usage.adoc

dracut.pc: Makefile.inc Makefile
	@echo "Name: dracut" > dracut.pc
	@echo "Description: dracut" >> dracut.pc
	@echo "Version: $(DRACUT_FULL_VERSION)" >> dracut.pc
	@echo "dracutdir=$(pkglibdir)" >> dracut.pc
	@echo "dracutmodulesdir=$(pkglibdir)/modules.d" >> dracut.pc
	@echo "dracutconfdir=$(pkglibdir)/dracut.conf.d" >> dracut.pc

install: all
	mkdir -p $(DESTDIR)$(pkglibdir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(sysconfdir)
	mkdir -p $(DESTDIR)$(pkglibdir)/modules.d
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man5 $(DESTDIR)$(mandir)/man7 $(DESTDIR)$(mandir)/man8
	install -m 0755 dracut.sh $(DESTDIR)$(bindir)/dracut
	install -m 0755 dracut-catimages.sh $(DESTDIR)$(bindir)/dracut-catimages
	install -m 0755 lsinitrd.sh $(DESTDIR)$(bindir)/lsinitrd
	install -m 0644 dracut.conf $(DESTDIR)$(sysconfdir)/dracut.conf
	mkdir -p $(DESTDIR)$(sysconfdir)/dracut.conf.d
	mkdir -p $(DESTDIR)$(pkglibdir)/dracut.conf.d
	install -m 0755 dracut-init.sh $(DESTDIR)$(pkglibdir)/dracut-init.sh
	install -m 0755 dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions.sh
	install -m 0755 dracut-version.sh $(DESTDIR)$(pkglibdir)/dracut-version.sh
	ln -fs dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions
	install -m 0755 dracut-logger.sh $(DESTDIR)$(pkglibdir)/dracut-logger.sh
	install -m 0755 dracut-initramfs-restore.sh $(DESTDIR)$(pkglibdir)/dracut-initramfs-restore
	cp -arx modules.d $(DESTDIR)$(pkglibdir)
	for conf in $(configs); do \
		install -D -m 0644 "dracut.conf.d/$$conf" "$(DESTDIR)$(pkglibdir)/dracut.conf.d/$$conf"; \
	done
	for i in $(configprofile) ; do \
		cp -arx dracut.conf.d/$$i/* $(DESTDIR)$(pkglibdir)/dracut.conf.d/ ;\
	done
ifeq ($(enable_test),yes)
	cp -arx test $(DESTDIR)$(pkglibdir)
	for conf in $(test_configs); do \
		install -D -m 0644 "dracut.conf.d/$$conf" "$(DESTDIR)$(pkglibdir)/dracut.conf.d/$$conf"; \
	done
else
	rm -rf $(DESTDIR)$(pkglibdir)/modules.d/70test*
endif
ifneq ($(enable_documentation),no)
	for i in $(man1pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man1/$${i##*/}; done
	for i in $(man5pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man5/$${i##*/}; done
	for i in $(man7pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man7/$${i##*/}; done
	for i in $(man8pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man8/$${i##*/}; done
	ln -fs dracut.cmdline.7 $(DESTDIR)$(mandir)/man7/dracut.kernel.7
endif
	if [ -n "$(systemdsystemunitdir)" ]; then \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir); \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77dracut-systemd/dracut-shutdown-onfailure.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown-onfailure.service; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77dracut-systemd/dracut-shutdown.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants; \
		ln -sf ../dracut-shutdown.service \
		$(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants; \
		for i in \
		    dracut-cmdline.service \
		    dracut-mount.service \
		    dracut-pre-mount.service \
		    dracut-pre-pivot.service \
		    dracut-pre-trigger.service \
		    dracut-pre-udev.service \
		    ; do \
			ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77dracut-systemd/$$i $(DESTDIR)$(systemdsystemunitdir); \
			ln -sf ../$$i \
			$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/$$i; \
		done; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77initqueue/dracut-initqueue.service $(DESTDIR)$(systemdsystemunitdir); \
		ln -sf ../dracut-initqueue.service \
		$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/dracut-initqueue.service; \
	fi
	if [ -f src/install/dracut-install ]; then \
		install -m 0755 src/install/dracut-install $(DESTDIR)$(pkglibdir)/dracut-install; \
	fi
	if [ -f src/skipcpio/skipcpio ]; then \
		install -m 0755 src/skipcpio/skipcpio $(DESTDIR)$(pkglibdir)/skipcpio; \
	fi
	if [ -f dracut-util ]; then \
		install -m 0755 dracut-util $(DESTDIR)$(pkglibdir)/dracut-util; \
	fi
ifeq ($(enable_dracut_cpio),yes)
	install -m 0755 dracut-cpio $(DESTDIR)$(pkglibdir)/dracut-cpio
endif
	mkdir -p $(DESTDIR)${prefix}/lib/kernel/install.d
	install -m 0755 install.d/50-dracut.install $(DESTDIR)${prefix}/lib/kernel/install.d/50-dracut.install
	install -m 0755 install.d/51-dracut-rescue.install $(DESTDIR)${prefix}/lib/kernel/install.d/51-dracut-rescue.install
	mkdir -p $(DESTDIR)${bashcompletiondir}
	install -m 0644 shell-completion/bash/dracut $(DESTDIR)${bashcompletiondir}/dracut
	install -m 0644 shell-completion/bash/lsinitrd $(DESTDIR)${bashcompletiondir}/lsinitrd
	mkdir -p $(DESTDIR)${pkgconfigdatadir}
	install -m 0644 dracut.pc $(DESTDIR)${pkgconfigdatadir}/dracut.pc
	if ! [ -n "$(systemdsystemunitdir)" ]; then \
		rm -rf $(DESTDIR)$(pkglibdir)/test/TEST-[0-9][0-9]-*SYSTEMD* ;\
		rm -rf $(DESTDIR)$(pkglibdir)/modules.d/*systemd* $(DESTDIR)$(mandir)/*.service.* ; \
		for i in bluetooth connman dbus* fido2 lvmmerge lvmthinpool-monitor memstrack pcsc pkcs11 rngd squash* tpm2-tss; do \
			rm -rf $(DESTDIR)$(pkglibdir)/modules.d/[0-9][0-9]$${i}; \
		done \
	fi

clean:
	$(RM) *~
	$(RM) */*~
	$(RM) */*/*~
	$(RM) $(manpages:%=%.xml) dracut.xml
	$(RM) dracut-*.tar.bz2 dracut-*.tar.xz
	$(RM) dracut-install src/install/dracut-install $(DRACUT_INSTALL_OBJECTS)
	$(RM) src/skipcpio/skipcpio $(SKIPCPIO_OBJECTS)
	$(RM) dracut-util src/util/util $(UTIL_OBJECTS)
	$(RM) $(manpages)
	$(RM) dracut.pc
	$(RM) dracut-cpio src/dracut-cpio/target/release/dracut-cpio*
	$(RM) -rf build/ doc_site/modules/ROOT/pages/man/*
	$(MAKE) -C test clean

syncheck:
	@ret=0;for i in dracut-initramfs-restore.sh modules.d/*/*.sh; do \
                [ "$${i##*/}" = "module-setup.sh" ] && continue; \
                read line < "$$i"; [ "$${line#*bash*}" != "$$line" ] && continue; \
		[ $$V ] && echo "posix syntax check: $$i"; bash --posix -n "$$i" ; ret=$$(($$ret+$$?)); \
		[ $$V ] && echo "checking for [[: $$i"; if grep -Fq '[[ ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains [["; fi; \
		[ $$V ] && echo "checking for echo -n: $$i"; if grep -Fq 'echo -n ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains echo -n"; fi \
	done;exit $$ret

=== src/install/Makefile ===
all:
	$(MAKE) -C ..

clean:
	$(MAKE) -C .. clean

.PHONY: all clean

=== debian/changelog ===
dracut (108-8ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - drop udevsettle patch (these kind of patches should be applied upstream)
    - dracut-core:
      - demote cryptsetup, systemd-cryptsetup, dmsetup, kpartx, lvm2,
        and mdadm to suggests
      - demote binutils to suggests. its only needed when using UEFI executables
    - Include all packages with dracut modules in Apport bug reports
    - autopkgtest: enable tests for s390x again
    - Plymouth hook: Use alternatives instead of plymouth-set-default-theme
    - run upstream-dracut-live autopkgtest on armhf and ppc64el
    - Drop debian-initramfs-post-update.patch. Let update-initramfs call the
      bootloader hooks instead of dracut itself.
    - plymouth: Only pull in the SimpleDRM driver by default
    - Let linux-firmware updates trigger the dracut autopkgtest
    - Cherry-pick some upstream fixes:
      - fix(dracut): use "-name" to avoid find matching temporary directory
      - fix(systemd-sysusers): increase ordering from 68 to 78
      - fix(dracut-systemd): avoid matching extra root= substrings in cmdline
      - fix(resume): avoid matching extra resume= substrings in cmdline
    - fix(udev-rules): exclude udev rules from snapd
  * feat(dmsquash-live-autooverlay): support readlink from uutils
  * test: use GNU dd instead of uutil's dd (to work around bug LP 2129037)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 20 Oct 2025 18:37:02 +0200

dracut (108-8) unstable; urgency=medium

  * dracut-test: fix dropped dependencies on i386

 -- Benjamin Drung <bdrung@debian.org>  Tue, 14 Oct 2025 18:35:08 +0200

dracut (108-7) unstable; urgency=medium

  * dracut-test: drop dependencies on i386 that are not present

 -- Benjamin Drung <bdrung@debian.org>  Tue, 14 Oct 2025 17:27:09 +0200

dracut (108-6) unstable; urgency=medium

  * test: allow running UEFI and kernel-install tests in chroot
  * autopkgtest: depend on bsdextrautils for rev command
  * Move common autopkgtest dependencies to dracut-test
  * autopkgtest: run every upstream test as separate test
  * autopkgtest: depend on util-linux-extra for switch_root in 30-dmsquash
  * test: skip using kernel-install due to bug #1117563
  * autopkgtest: copy dracut.conf.d into test directory

 -- Benjamin Drung <bdrung@debian.org>  Tue, 07 Oct 2025 23:45:56 +0200

dracut (108-5) unstable; urgency=medium

  * autopkgtest: drop skipping removed TEST-23-IMSM
  * Fix kernel-install test cases by avoiding add-all call
  * fix(Makefile): exclude hidden directories from shellcheck part 2

 -- Benjamin Drung <bdrung@debian.org>  Fri, 26 Sep 2025 10:55:23 +0200

dracut (108-4) unstable; urgency=medium

  * Drop build dependency on shfmt on archs where it is not available
  * fix(dracut): library directory creation in --kernel-only
  * dracut-core: Prefer 3cpio over cpio
  * autopkgtest: install pkgconf for TEST-40-SYSTEMD
  * fix(lsinitrd): use lowercase skip variable name

 -- Benjamin Drung <bdrung@debian.org>  Thu, 25 Sep 2025 16:23:44 +0200

dracut (108-3ubuntu3) questing; urgency=medium

  * Default to cpio until 3cpio MIR is complete
  * Cherry-pick some upstream fixes:
    - fix(dracut): use "-name" to avoid find matching temporary directory
    - fix(systemd-sysusers): increase ordering from 68 to 78
    - fix(dracut-systemd): avoid matching extra root= substrings in cmdline
    - fix(resume): avoid matching extra resume= substrings in cmdline
  * fix(udev-rules): exclude udev rules from snapd

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 04 Sep 2025 23:20:52 +0200

dracut (108-3ubuntu2) questing; urgency=medium

  * fix(dracut): library directory creation in --kernel-only

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 14 Aug 2025 20:39:46 +0200

dracut (108-3ubuntu1) questing; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - drop udevsettle patch (these kind of patches should be applied upstream)
    - dracut-core:
      - demote cryptsetup, systemd-cryptsetup, dmsetup, kpartx, lvm2,
        and mdadm to suggests
      - demote binutils to suggests. its only needed when using UEFI executables
    - Include all packages with dracut modules in Apport bug reports
    - autopkgtest: enable tests for s390x again
    - Plymouth hook: Use alternatives instead of plymouth-set-default-theme
    - run upstream-dracut-live autopkgtest on armhf and ppc64el
    - Drop debian-initramfs-post-update.patch. Let update-initramfs call the
      bootloader hooks instead of dracut itself.
    - plymouth: Only pull in the SimpleDRM driver by default
    - Let linux-firmware updates trigger the dracut autopkgtest
  * Depend on 3cpio instead of cpio

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 13 Aug 2025 23:08:38 +0200

dracut (108-3) unstable; urgency=medium

  * Cherry-pick upstream commits to simplify debian/rules:
    - feat(Makefile): introduce distclean target
    - fix(hwdb): make module-setup.sh executable
    - fix(Makefile): use install for installing files
  * autopkgtest: drop sysvinit-utils and util-linux dependencies
  * dracut-test: depend on mount for mount/umount commands
  * Support shellcheck 0.11
  * Cherry-pick some upstream fixes:
    - fix(dracut-util): crash if CMDLINE ends with quotation mark
    - fix(kernel-modules): add Cadence USB driver to base (Closes: #1108924)
    - fix(lsinitrd): avoid rechecking for squash images
  * Support 3cpio for creating and listing initrds

 -- Benjamin Drung <bdrung@debian.org>  Wed, 13 Aug 2025 14:07:00 +0200

dracut (108-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - drop udevsettle patch (these kind of patches should be applied upstream)
    - dracut-core:
      - demote cryptsetup, systemd-cryptsetup, dmsetup, kpartx, lvm2,
        and mdadm to suggests
      - demote binutils to suggests. its only needed when using UEFI executables
    - Include all packages with dracut modules in Apport bug reports


=== debian/control ===
Source: dracut
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Lange <lange@debian.org>
Uploaders: Benjamin Drung <bdrung@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-apport,
               3cpio [!alpha !hppa !m68k !sh4] <!nocheck>,
               asciidoctor,
               bash-completion,
               cpio [alpha hppa m68k sh4] <!nocheck>,
               libkmod-dev,
               pkgconf,
               shellcheck [!i386 !m68k !powerpc !sh4 !x32] <!nocheck>,
               shfmt [!alpha !hppa !i386 !m68k !powerpc !sh4 !sparc64 !x32] <!nocheck>,
               systemd-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/dracut
Vcs-Git: https://salsa.debian.org/debian/dracut.git
Homepage: https://github.com/dracut-ng/dracut-ng/wiki

Package: dracut-core
Architecture: any
Multi-Arch: foreign
Depends: 3cpio | cpio,
         dracut-install,
         e2fsprogs,
         kmod,
         systemd-sysv | initscripts | sysvinit-core,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: console-setup, systemd, zstd
Suggests: binutils,
          cryptsetup,
          dmsetup,
          kpartx,
          lvm2,
          mdadm,
          systemd-cryptsetup
Breaks: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
Replaces: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
Description: dracut is an event driven initramfs infrastructure (core tools)
 Unlike existing initramfs's, this is an attempt at having as little as
 possible hard-coded into the initramfs as possible.  The initramfs has
 (basically) one purpose in life -- getting the rootfs mounted so that
 it can transition to the real rootfs.  This is all driven off of
 device availability.  Therefore, instead of scripts hard-coded to do
 various things, it depends on udev to create device nodes and
 to detect the rootfs.
 Having the root on MD, LVM2, LUKS is supported as well as NFS, iSCSI,
 NBD and FCOE with dracut-network.

Package: dracut
Architecture: all
Multi-Arch: foreign
Depends: dracut-core (<< ${binary:Version}+b+~),
         dracut-core (>= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: dracut-network
Provides: linux-initramfs-tool
Conflicts: initramfs-tools, live-tools
Description: Initramfs generator using udev
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: dracut-install
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dracut-core (<< 060+5-7~)
Replaces: dracut-core (<< 060+5-7~)
Description: dracut is an event driven initramfs infrastructure (dracut-install)
 This package just contains the dracut-install command to be used by
 initramfs generating tools.

Package: dracut-network
Architecture: all
Multi-Arch: foreign
Depends: dracut-core,
         iproute2,
         iputils-arping,
         network-manager | systemd | connman | isc-dhcp-client,
         ${misc:Depends}
Recommends: curl, nbd-client, nfs-common, open-iscsi
Suggests: iscsiuio
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (network modules)
 Package to build a dracut initramfs with network support. This
 includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.

Package: dracut-squash
Architecture: all
Multi-Arch: foreign
Depends: dracut-core, squashfs-tools, ${misc:Depends}
Breaks: dracut-core (<< 050-1)
Replaces: dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (squashfs modules)
 Package to build an initramfs with most files in a squashfs image.
 .
 This package provides a dracut module to build an initramfs, but
 store most files in a squashfs image, result in a smaller initramfs
 size and reduce runtime memory usage.

Package: dracut-live
Architecture: all
Multi-Arch: foreign
Depends: dmsetup, dracut-core, ${misc:Depends}
Recommends: dracut-network
Suggests: isomd5sum
Breaks: dracut-core (<< 050-1), dracut-network (<< 050-1)
Replaces: dracut-core (<< 050-1), dracut-network (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (live image modules)
 Package to build a dracut initramfs with live image capabilities.
 .
 This package requires everything which is needed to build an
 initramfs with dracut, with live image capabilities, like Live CDs.

Package: dracut-test
Architecture: any
Multi-Arch: foreign
Depends: bsdextrautils,
         cryptsetup,
         dracut-core,
         ipxe-qemu,
         linux-image-generic [!i386],
         lvm2,
         make,
         mdadm [!i386],
         mount,
         ovmf,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-system-native [!i386],
         seabios [ppc64el],
         systemd,
         systemd-cryptsetup,
         zstd,
         ${misc:Depends}
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (test modules)
 This package provides the Dracut modules and configuration files for the
 Dracut test suite. This package is intended for testing Dracut itself
 and is of no use for ordinary users. If you're not sure about this package,
 you don't need it.
 .
 This package has following additional dependencies for reducing the amount
 of dependencies needed in autopkgtest:
 .
  * bsdextrautils for rev command
  * Linux kernel
  * make
  * QEMU
  * Recommends from dracut-core

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DRACUT_MAIN_VERSION=$(DEB_VERSION_UPSTREAM_REVISION)
export DRACUT_FULL_VERSION=$(DEB_VERSION)

deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@ --with apport,bash-completion

override_dh_auto_configure:
	dh_auto_configure -- --configprofile=debian --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/lib/dracut/modules.d/77dracut-systemd/*.adoc
	rm debian/tmp/usr/lib/dracut/modules.d/77dracut-systemd/*.8

override_dh_fixperms-indep:
	dh_fixperms
ifneq ($(DEB_HOST_ARCH), s390x)
	for m in 68cms 69cio_ignore 73zipl 74dasd 74dasd_mod \
		74dcssblk 74zfcp 74znet; do \
		rm -r debian/*/usr/lib/dracut/modules.d/$$m ; \
	done
else
	rm -r debian/*/usr/lib/dracut/modules.d/00warpclock
endif

override_dh_auto_test:
	make -C test check TESTS="80 81"
	make syncheck

override_dh_install:
	dh_install
	dh_install -pdracut-core $(deb_systemdsystemunitdir)

=== debian/tests/control ===
Tests: lsinitrd
Architecture: !armel !i386
Depends: dracut, linux-image-generic, zstd
Restrictions: needs-root, superficial

# Skip following test cases:
# * TEST-43-KERNEL-INSTALL: kernel-install issue, see https://bugs.debian.org/1117563
# * TEST-61-MULTINIC: disabled in upstream CI since 2023-01-02
# * TEST-62-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
# arm64, armhf, and ppc64el need upstream support: https://github.com/dracutdevs/dracut/issues/2493

Tests: 10-basic,
       11-usr-mount,
       12-uefi,
       13-sysroot,
       20-storage,
       26-enc-raid-lvm,
       40-systemd,
       41-full-systemd,
       42-systemd-initrd,
       80-getarg,
       81-skipcpio
Architecture: amd64 s390x
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs,
         busybox,
         dbus,
         dracut-core,
         dracut-test,
         fdisk,
         kbd,
         pkgconf,
         squashfs-tools,
         systemd-boot-efi [amd64 arm64 armhf riscv64],
         systemd-container,
         systemd-coredump,
         systemd-repart,
         systemd-ukify

Tests: 30-dmsquash
Architecture: amd64 armhf ppc64el s390x
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs,
         busybox,
         dracut-live,
         dracut-test,
         fdisk,
         kbd,
         parted,
         squashfs-tools,
         util-linux-extra

Tests: 60-nfs
Architecture: amd64 s390x
Restrictions: allow-stderr, needs-root
Depends: curl,
         dracut-live,
         dracut-network,
         dracut-test,
         isc-dhcp-client,
         isc-dhcp-server,
         nfs-kernel-server,
         procps

Tests: 70-iscsi, 71-iscsi-multi
Architecture: amd64 s390x
Restrictions: allow-stderr, needs-root
Depends: dracut-network,
         dracut-test,
         isc-dhcp-client,
         isc-dhcp-server,
         open-iscsi,
         procps,
         tgt

Tests: 72-nbd
Architecture: amd64 s390x
Restrictions: allow-stderr, needs-root
Depends: dracut-network,
         dracut-test,
         isc-dhcp-client,
         isc-dhcp-server,
         nbd-client,
         nbd-server,
         procps

# Dummy test so that linux-firmware updates trigger our other autopkgtests
Features: test-name=hint-testsuite-triggers
Test-Command: false
Depends: linux-firmware
Restrictions: hint-testsuite-triggers

## dracut 109

=== test/TEST-70-ISCSI/Makefile ===
-include ../Makefile.testdir

ibft.table: Makefile ibft.pl
	perl ibft.pl \
		--initiator iqn=iqn.1994-05.com.redhat:633114aacf2 \
		--nic ip=192.168.50.101,prefix=24,gw=192.168.50.1,dns1=192.168.50.1,dhcp=192.168.50.1,mac=52:54:00:12:34:00,pci=00:03.0 \
		--target nic=0,ip=192.168.50.1,port=3260,lun=1,name=iqn.2009-06.dracut:target0 >$@

=== debian/changelog ===
dracut (109-5) unstable; urgency=medium

  * test(run-qemu): use hvc0 console on s390x (Closes: #1120955)

 -- Benjamin Drung <bdrung@debian.org>  Sat, 29 Nov 2025 00:43:17 +0100

dracut (109-4) unstable; urgency=medium

  * test: update UEFI patches to the version merged upstream

 -- Benjamin Drung <bdrung@debian.org>  Wed, 26 Nov 2025 01:17:48 +0100

dracut (109-3) unstable; urgency=medium

  * test:
    - forward journald logs to console in V=1 or V=2
    - replace rev command by sed and drop bsdextrautils dependency
    - use UEFI for QEMU when available and support UEFI on ARM
  * dracut-test: ovmf is only needed for amd64
  * Drop debian-initramfs-post-update.patch because the update-initramfs
    script (shipped by dracut) invokes the bootloader hooks from
    /etc/initramfs/post-update.d. (Closes: #1091455)
  * autopkgtest: Skip failing (hanging) 41-full-systemd on s390x
    (Closes: #1120955)

 -- Benjamin Drung <bdrung@debian.org>  Tue, 25 Nov 2025 19:40:40 +0100

dracut (109-2) unstable; urgency=medium

  * Fix FTCBFS: Export ARCH for make (Closes: #1120911)
  * fix(systemd-networkd): install and enable
    systemd-networkd-resolve-hook.socket (Closes: #1120955)
  * dracut-live: depend on parted for dmsquash-live-autooverlay
  * autopkgtest: remove unneeded dependencies
  * autopkgtest: run kernel-install tests again after #1117563 got fixed
  * Add Apport hook to include all packages with dracut modules in report
    (LP: #2081183)
  * test: exit with code 77 if test is skipped
  * dracut-core: demote *cryptsetup, dmsetup, kpartx, lvm2, mdadm to suggests
    These packages should be installed in case they are needed for the disk
    setup but should not installed by default via Recommends.
  * test: set console cmdline depending on the architecture
  * run autopkgtest on all relevant architectures (LP: #2115532)

 -- Benjamin Drung <bdrung@debian.org>  Wed, 19 Nov 2025 17:15:22 +0100

dracut (109-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches applied upstream and refresh remaining patches
  * test: remove test module
  * fix(debian): lower the ordering number for debian conf
  * fix(systemd-sysusers): increase ordering from 68 to 78
  * Provide separate install files for s390x
  * dracut-core: add new module kernel-modules-export
  * autopkgtest: test 30-DMSQUASH requires dracut-network now
  * autopkgtest: run full systemd test separately with a separate set of
    additional dependencies.
  * autopkgtest: add test 44-drivers and 50-network
  * debian/rules: drop explicit --configprofile configure option
  * fix(dracut): decrease logging by default
  * autopkgtest: drop unneeded dbus and isc-dhcp-client dependency
  * update-initramfs: drop intermediate initrd.new (see bug 1116593)
  * autopkgtest: drop setting KVERSION
  * configure: disable dracut-cpio explicitly
  * Upgrade debian/watch to version 5
  * Drop Rules-Requires-Root: no, which is the default now

 -- Benjamin Drung <bdrung@debian.org>  Wed, 05 Nov 2025 10:27:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,9 @@
 Source: dracut
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Lange <lange@debian.org>
+Maintainer: Thomas Lange <lange@debian.org>
 Uploaders: Benjamin Drung <bdrung@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               dh-apport,
                3cpio [!alpha !hppa !m68k !sh4] <!nocheck>,
                asciidoctor,
                bash-completion,
@@ -15,7 +13,6 @@
                shellcheck [!i386 !m68k !powerpc !sh4 !x32] <!nocheck>,
                shfmt [!alpha !hppa !i386 !m68k !powerpc !sh4 !sparc64 !x32] <!nocheck>,
                systemd-dev
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/dracut
 Vcs-Git: https://salsa.debian.org/debian/dracut.git
@@ -32,14 +29,8 @@
          udev,
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: console-setup, systemd, zstd
-Suggests: binutils,
-          cryptsetup,
-          dmsetup,
-          kpartx,
-          lvm2,
-          mdadm,
-          systemd-cryptsetup
+Recommends: binutils, console-setup, systemd, zstd
+Suggests: cryptsetup, dmsetup, kpartx, lvm2, mdadm, systemd-cryptsetup
 Breaks: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
 Replaces: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
 Description: dracut is an event driven initramfs infrastructure (core tools)
@@ -109,7 +100,7 @@
 Package: dracut-live
 Architecture: all
 Multi-Arch: foreign
-Depends: dmsetup, dracut-core, ${misc:Depends}
+Depends: dmsetup, dracut-core, parted, ${misc:Depends}
 Recommends: dracut-network
 Suggests: isomd5sum
 Breaks: dracut-core (<< 050-1), dracut-network (<< 050-1)
@@ -123,22 +114,17 @@
 Package: dracut-test
 Architecture: any
 Multi-Arch: foreign
-Depends: bsdextrautils,
-         cryptsetup,
-         dracut-core,
+Depends: dracut-core,
          ipxe-qemu,
          linux-image-generic [!i386],
-         lvm2,
          make,
-         mdadm [!i386],
          mount,
-         ovmf,
+         ovmf [amd64],
          qemu-efi-aarch64 [arm64],
          qemu-efi-arm [armhf],
          qemu-system-native [!i386],
          seabios [ppc64el],
-         systemd,
-         systemd-cryptsetup,
+         systemd (>= 259~rc1),
          zstd,
          ${misc:Depends}
 Breaks: dracut-core (<< 105)
@@ -152,7 +138,6 @@
  This package has following additional dependencies for reducing the amount
  of dependencies needed in autopkgtest:
  .
-  * bsdextrautils for rev command
   * Linux kernel
   * make
   * QEMU

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export ARCH=$(DEB_HOST_ARCH_CPU)
export DRACUT_MAIN_VERSION=$(DEB_VERSION_UPSTREAM_REVISION)
export DRACUT_FULL_VERSION=$(DEB_VERSION)

deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@ --with bash-completion

override_dh_auto_configure:
	dh_auto_configure -- --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib --disable-dracut-cpio

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/lib/dracut/modules.d/77dracut-systemd/*.adoc
	rm debian/tmp/usr/lib/dracut/modules.d/77dracut-systemd/*.8

override_dh_auto_test:
	make -C test check TESTS="80 81"
	make syncheck

override_dh_install:
	dh_install
	dh_install -pdracut-core $(deb_systemdsystemunitdir)

=== debian/tests/control ===
Tests: lsinitrd
Architecture: !armel !i386
Depends: dracut, linux-image-generic, zstd
Restrictions: needs-root, superficial

Tests: 10-basic,
       13-sysroot,
       40-systemd,
       42-systemd-initrd,
       43-kernel-install,
       80-getarg,
       81-skipcpio
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: dracut-test

Tests: 11-usr-mount
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs, dracut-test

# Fails on arm64: https://github.com/dracut-ng/dracut-ng/issues/1862
Tests: 12-uefi
Architecture: amd64
Restrictions: allow-stderr, needs-root
Depends: dracut-test,
         kbd,
         lvm2,
         squashfs-tools,
         systemd-boot-efi,
         systemd-cryptsetup,
         systemd-ukify

Tests: 20-storage, 26-enc-raid-lvm
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: cryptsetup, dracut-test, lvm2, mdadm, systemd-cryptsetup

Tests: 30-dmsquash
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: dracut-live,
         dracut-network,
         dracut-test,
         fdisk,
         squashfs-tools,
         util-linux-extra

Tests: 41-full-systemd
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs,
         cryptsetup,
         dracut-network,
         dracut-test,
         systemd-container,
         systemd-coredump,
         systemd-cryptsetup,
         systemd-repart,
         systemd-resolved,
         systemd-timesyncd

Tests: 44-drivers
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: dracut-test, xfsprogs

Tests: 50-network
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: dracut-network, dracut-test

Tests: 60-nfs
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: curl,
         dracut-live,
         dracut-network,
         dracut-test,
         isc-dhcp-server,
         nfs-kernel-server,
         procps

Tests: 70-iscsi, 71-iscsi-multi
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: cryptsetup,
         dracut-network,
         dracut-test,
         isc-dhcp-server,
         lvm2,
         mdadm,
         open-iscsi,
         procps,
         systemd-cryptsetup,
         tgt

Tests: 72-nbd
Architecture: !armel !i386 !riscv64
Restrictions: allow-stderr, needs-root
Depends: cryptsetup,
         dracut-network,
         dracut-test,
         isc-dhcp-server,
         lvm2,
         mdadm,
         nbd-client,
         nbd-server,
         procps,
         systemd-cryptsetup
